const cors = require("cors");
const express = require("express");
const bodyParser = require("body-parser");
const { createData, shuffleArray } = require("./utils");

const app = express();
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cors());

app.get("/data/:timeFrame", (req, res) => {
  try {
    const count = req.query.count || 0;
    const timeFrame = req.params.timeFrame || 0;

    return res.send({
      data: shuffleArray(createData(count, timeFrame)),
    });
  } catch (err) {
    console.log(err);
    return res.send({ data: [] });
  }
});

app.listen(3001);
console.log("🛠  https://127.0.0.1:3001");