const addDate = (date) => {
  return new Date(date.getTime() + 30000);
};

const radomPosOrNeg = () => {
  return Math.random() > 0.5 ? 1 : -1;
};

const radomCoefficient = () => {
  return Math.random() > 0.65 ? 2 : 1;
};

const radomPrice = () => {
  const random = Math.random();
  if (random < 0.3) {
    return 5;
  } else if (random < 0.8) {
    return 10;
  }
  return 20;
};

const generateNewPrice = (prevPrice) => {
  return Math.abs(
    Math.min(
      200,
      prevPrice + radomPosOrNeg() * radomCoefficient() * radomPrice()
    )
  );
};

const createData = (count, timeFrame) => {
  const data = [];

  let prevDate = new Date();
  prevDate.setSeconds(0, 0);

  let prevPrice = 0;

  for (let i = 1; i <= count; i++) {
    prevDate = i === 1 ? prevDate : addDate(prevDate);
    if ((i - 1) % timeFrame !== 0) {
      prevPrice = generateNewPrice(prevPrice);
    }
    data.push({
      date: prevDate.toISOString(),
      price: prevPrice,
    });
  }

  return data;
};

const shuffleArray = (array) => {
  const newArr = [...array];
  for (let i = newArr.length - 1; i > 0; i--) {
    const j = Math.floor(Math.random() * (i + 1));
    [newArr[i], newArr[j]] = [newArr[j], newArr[i]];
  }
  return newArr;
};

module.exports = {
  createData,
  shuffleArray,
};
